// dynamic memory allocation
/*
// advantages:
1. You can specify the size at RUNTIME
2. You can get more memory than on the stack
3. It sticks around (it does not disappear automatically)

You can use up the memory on the heap if you keep allocating
large arrays.
You should delete all dynamically allocated memory when you are done using it.
You do not have to delete in the same function that you allocated.
*/


#include <iostream>
#include <cstdlib>
using namespace std;

int main()
{
/*
    int * iptr=NULL;
//RUN TIME ERROR!
//cout<<" the value iptr represents is "<<*iptr<<endl;
    //until now:
    int numStudents;
    iptr = &numStudents;

    iptr = new int;
    *iptr = 30;
cout<<" the value iptr represents is "<<*iptr<<endl;
    //many lines of code later...
    //can allocate more space but previous int still exists!
    delete iptr;
    iptr = NULL;
//RUN TIME ERROR!
//cout<<" the value iptr represents is "<<*iptr<<endl;
    iptr =new int;
    *iptr = 500;
cout<<" the value iptr represents is "<<*iptr<<endl;
*/
  const int SIZE=1000;
  int num;

  int arr[SIZE];  // known at compile time

  // new operator  returns a pointer
  int *iptr;

  cout << "enter a number of elements: ";
  cin >> num;

// give me an array of num elements of type int
try {
//  for (int i=0;i<1000000;i++){
     //cout << "i= " << i << endl;
     iptr =  new int[num];

    }
    //}

// newer compilers throw and exception called bad_alloc
  catch(bad_alloc)
    {  cout << "the memory was NOT allocated!!!" << endl;
       exit(1);
    }

/***************
// older compilers return NULL
  if (iptr==NULL)
      cout << "memory was not able to be allocated" << endl;
***************/



if (num>5)
{
// put a 6 into the 5th location of this dynamic array
  *(iptr+5)=6;
//OR
 //  iptr[5]=6;

}

for (int i =0; i< num; i++)
{
    *(iptr+i)=i;
    cout<< "iptr[" << i<<"]=" <<iptr[i]<<endl;
}

int total=0;
for (int i =0; i< num; i++)
{
    total+=*(iptr+i);
}

cout<< "the total of this array is " << total;

// When you are done with the array, you ask the heap to
// free it up by using the delete operator

delete [] iptr;


  return 0;
}
